Add shelltests for hspace allocation
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/Curl \
68         src/Ganeti/DataCollectors \
69         src/Ganeti/HTools \
70         src/Ganeti/HTools/Backend \
71         src/Ganeti/HTools/Program \
72         src/Ganeti/Hypervisor \
73         src/Ganeti/Hypervisor/Xen \
74         src/Ganeti/Monitoring \
75         src/Ganeti/Query \
76         test/hs \
77         test/hs/Test \
78         test/hs/Test/Ganeti \
79         test/hs/Test/Ganeti/Block \
80         test/hs/Test/Ganeti/Block/Drbd \
81         test/hs/Test/Ganeti/Confd \
82         test/hs/Test/Ganeti/HTools \
83         test/hs/Test/Ganeti/HTools/Backend \
84         test/hs/Test/Ganeti/Hypervisor \
85         test/hs/Test/Ganeti/Hypervisor/Xen \
86         test/hs/Test/Ganeti/Query
87
88 # Haskell directories without the roots (src, test/hs)
89 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
90
91 DIRS = \
92         $(HS_DIRS) \
93         autotools \
94         daemons \
95         devel \
96         devel/data \
97         doc \
98         doc/css \
99         doc/examples \
100         doc/examples/gnt-debug \
101         doc/examples/hooks \
102         test/data/htools \
103         test/data/htools/rapi \
104         test/hs/shelltests \
105         lib \
106         lib/build \
107         lib/client \
108         lib/confd \
109         lib/http \
110         lib/hypervisor \
111         lib/impexpd \
112         lib/masterd \
113         lib/rapi \
114         lib/server \
115         lib/tools \
116         lib/utils \
117         lib/watcher \
118         man \
119         qa \
120         test \
121         test/data \
122         test/data/bdev-rbd \
123         test/data/ovfdata \
124         test/data/ovfdata/other \
125         test/py \
126         tools
127
128 ALL_APIDOC_HS_DIRS = \
129         $(APIDOC_HS_DIR) \
130         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
131
132 BUILDTIME_DIR_AUTOCREATE = \
133         scripts \
134         $(APIDOC_DIR) \
135         $(ALL_APIDOC_HS_DIRS) \
136         $(APIDOC_PY_DIR) \
137         $(COVERAGE_DIR) \
138         $(COVERAGE_HS_DIR) \
139         $(COVERAGE_PY_DIR) \
140         .hpc
141
142 BUILDTIME_DIRS = \
143         $(BUILDTIME_DIR_AUTOCREATE) \
144         doc/html \
145         doc/man-html
146
147 DIRCHECK_EXCLUDE = \
148         $(BUILDTIME_DIRS) \
149         ganeti-[0-9]*.[0-9]*.[0-9]* \
150         doc/html/_* \
151         doc/man-html/_* \
152         autom4te.cache
153
154 # some helper vars
155 COVERAGE_DIR = doc/coverage
156 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
157 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
158 APIDOC_DIR = doc/api
159 APIDOC_PY_DIR = $(APIDOC_DIR)/py
160 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
161
162 MAINTAINERCLEANFILES = \
163         $(maninput) \
164         doc/install-quick.rst \
165         doc/news.rst \
166         doc/upgrade.rst \
167         vcs-version
168
169 maintainer-clean-local:
170         rm -rf $(BUILDTIME_DIRS)
171
172 CLEANFILES = \
173         $(addsuffix /*.py[co],$(DIRS)) \
174         $(addsuffix /*.hi,$(HS_DIRS)) \
175         $(addsuffix /*.o,$(HS_DIRS)) \
176         $(PYTHON_BOOTSTRAP) \
177         epydoc.conf \
178         $(REPLACE_VARS_SED) \
179         $(SHELL_ENV_INIT) \
180         daemons/daemon-util \
181         daemons/ganeti-cleaner \
182         devel/squeeze-amd64.tar.gz \
183         devel/squeeze-amd64.conf \
184         $(mandocrst) \
185         doc/manpages-enabled.rst \
186         $(BUILT_EXAMPLES) \
187         doc/examples/bash_completion \
188         doc/examples/bash_completion-debug \
189         lib/_generated_rpc.py \
190         $(man_MANS) \
191         $(manhtml) \
192         tools/kvm-ifup \
193         tools/users-setup \
194         tools/vcluster-setup \
195         stamp-directories \
196         stamp-srclinks \
197         $(nodist_pkgpython_PYTHON) \
198         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
199         $(HS_BUILT_TEST_HELPERS) \
200         src/ganeti-confd \
201         src/ganeti-mond \
202         .hpc/*.mix src/*.tix test/hs/*.tix \
203         doc/hs-lint.html
204
205 GENERATED_FILES = \
206         $(built_base_sources) \
207         $(BUILT_PYTHON_SOURCES) \
208         $(PYTHON_BOOTSTRAP)
209
210 HS_GENERATED_FILES =
211 if WANT_HTOOLS
212 HS_GENERATED_FILES += $(HS_PROGS)
213 if ENABLE_CONFD
214 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
215 endif
216
217 if ENABLE_MOND
218 HS_GENERATED_FILES += src/ganeti-mond
219 endif
220 endif
221
222 built_base_sources = \
223         stamp-directories \
224         stamp-srclinks
225
226 built_python_base_sources = \
227         lib/_autoconf.py \
228         lib/_vcsversion.py
229
230 BUILT_PYTHON_SOURCES = \
231         $(built_python_base_sources) \
232         lib/_generated_rpc.py
233
234 # Generating the RPC wrappers depends on many things, so make sure
235 # it's built at the end of the built sources
236 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
237
238 # these are all built from the underlying %.in sources
239 BUILT_EXAMPLES = \
240         doc/examples/ganeti-kvm-poweroff.initd \
241         doc/examples/ganeti.cron \
242         doc/examples/ganeti.initd \
243         doc/examples/ganeti-master-role.ocf \
244         doc/examples/ganeti-node-role.ocf \
245         doc/examples/gnt-config-backup \
246         doc/examples/hooks/ipsec
247
248 nodist_pkgpython_PYTHON = \
249         $(BUILT_PYTHON_SOURCES)
250
251 noinst_PYTHON = \
252         lib/build/__init__.py \
253         lib/build/shell_example_lexer.py \
254         lib/build/sphinx_ext.py
255
256 pkgpython_PYTHON = \
257         lib/__init__.py \
258         lib/asyncnotifier.py \
259         lib/backend.py \
260         lib/bdev.py \
261         lib/bootstrap.py \
262         lib/cli.py \
263         lib/cmdlib.py \
264         lib/compat.py \
265         lib/config.py \
266         lib/constants.py \
267         lib/daemon.py \
268         lib/errors.py \
269         lib/hooksmaster.py \
270         lib/ht.py \
271         lib/jqueue.py \
272         lib/jstore.py \
273         lib/locking.py \
274         lib/luxi.py \
275         lib/mcpu.py \
276         lib/netutils.py \
277         lib/objects.py \
278         lib/opcodes.py \
279         lib/outils.py \
280         lib/ovf.py \
281         lib/pathutils.py \
282         lib/qlang.py \
283         lib/query.py \
284         lib/rpc.py \
285         lib/rpc_defs.py \
286         lib/runtime.py \
287         lib/serializer.py \
288         lib/ssconf.py \
289         lib/ssh.py \
290         lib/storage.py \
291         lib/uidpool.py \
292         lib/vcluster.py \
293         lib/network.py \
294         lib/workerpool.py
295
296 client_PYTHON = \
297         lib/client/__init__.py \
298         lib/client/gnt_backup.py \
299         lib/client/gnt_cluster.py \
300         lib/client/gnt_debug.py \
301         lib/client/gnt_group.py \
302         lib/client/gnt_instance.py \
303         lib/client/gnt_job.py \
304         lib/client/gnt_node.py \
305         lib/client/gnt_network.py \
306         lib/client/gnt_os.py \
307         lib/client/gnt_storage.py
308
309 hypervisor_PYTHON = \
310         lib/hypervisor/__init__.py \
311         lib/hypervisor/hv_base.py \
312         lib/hypervisor/hv_chroot.py \
313         lib/hypervisor/hv_fake.py \
314         lib/hypervisor/hv_kvm.py \
315         lib/hypervisor/hv_lxc.py \
316         lib/hypervisor/hv_xen.py
317
318 rapi_PYTHON = \
319         lib/rapi/__init__.py \
320         lib/rapi/baserlib.py \
321         lib/rapi/client.py \
322         lib/rapi/client_utils.py \
323         lib/rapi/connector.py \
324         lib/rapi/rlib2.py \
325         lib/rapi/testutils.py
326
327 http_PYTHON = \
328         lib/http/__init__.py \
329         lib/http/auth.py \
330         lib/http/client.py \
331         lib/http/server.py
332
333 confd_PYTHON = \
334         lib/confd/__init__.py \
335         lib/confd/client.py
336
337 masterd_PYTHON = \
338         lib/masterd/__init__.py \
339         lib/masterd/iallocator.py \
340         lib/masterd/instance.py
341
342 impexpd_PYTHON = \
343         lib/impexpd/__init__.py
344
345 watcher_PYTHON = \
346         lib/watcher/__init__.py \
347         lib/watcher/nodemaint.py \
348         lib/watcher/state.py
349
350 server_PYTHON = \
351         lib/server/__init__.py \
352         lib/server/masterd.py \
353         lib/server/noded.py \
354         lib/server/rapi.py
355
356 pytools_PYTHON = \
357         lib/tools/__init__.py \
358         lib/tools/burnin.py \
359         lib/tools/ensure_dirs.py \
360         lib/tools/node_cleanup.py \
361         lib/tools/node_daemon_setup.py \
362         lib/tools/prepare_node_join.py
363
364 utils_PYTHON = \
365         lib/utils/__init__.py \
366         lib/utils/algo.py \
367         lib/utils/filelock.py \
368         lib/utils/hash.py \
369         lib/utils/io.py \
370         lib/utils/log.py \
371         lib/utils/lvm.py \
372         lib/utils/mlock.py \
373         lib/utils/nodesetup.py \
374         lib/utils/process.py \
375         lib/utils/retry.py \
376         lib/utils/text.py \
377         lib/utils/wrapper.py \
378         lib/utils/x509.py
379
380 docinput = \
381         doc/conf.py \
382         doc/css/style.css \
383         doc/admin.rst \
384         doc/cluster-merge.rst \
385         doc/design-2.0.rst \
386         doc/design-2.1.rst \
387         doc/design-2.2.rst \
388         doc/design-2.3.rst \
389         doc/design-2.4.rst \
390         doc/design-2.5.rst \
391         doc/design-2.6.rst \
392         doc/design-2.7.rst \
393         doc/design-autorepair.rst \
394         doc/design-bulk-create.rst \
395         doc/design-chained-jobs.rst \
396         doc/design-cpu-pinning.rst \
397         doc/design-device-uuid-name.rst \
398         doc/design-draft.rst \
399         doc/design-htools-2.3.rst \
400         doc/design-http-server.rst \
401         doc/design-impexp2.rst \
402         doc/design-lu-generated-jobs.rst \
403         doc/design-linuxha.rst \
404         doc/design-multi-reloc.rst \
405         doc/design-network.rst \
406         doc/design-node-add.rst \
407         doc/design-oob.rst \
408         doc/design-ovf-support.rst \
409         doc/design-opportunistic-locking.rst \
410         doc/design-partitioned.rst \
411         doc/design-query-splitting.rst \
412         doc/design-query2.rst \
413         doc/design-reason-trail.rst \
414         doc/design-resource-model.rst \
415         doc/design-restricted-commands.rst \
416         doc/design-shared-storage.rst \
417         doc/design-monitoring-agent.rst \
418         doc/design-virtual-clusters.rst \
419         doc/design-x509-ca.rst \
420         doc/design-hroller.rst \
421         doc/design-storagetypes.rst \
422         doc/devnotes.rst \
423         doc/glossary.rst \
424         doc/hooks.rst \
425         doc/iallocator.rst \
426         doc/index.rst \
427         doc/install-quick.rst \
428         doc/install.rst \
429         doc/locking.rst \
430         doc/manpages-disabled.rst \
431         doc/move-instance.rst \
432         doc/news.rst \
433         doc/ovfconverter.rst \
434         doc/rapi.rst \
435         doc/security.rst \
436         doc/upgrade.rst \
437         doc/virtual-cluster.rst \
438         doc/walkthrough.rst
439
440 # Generates file names such as "doc/man-gnt-instance.rst"
441 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
442
443 # Haskell programs to be installed in $PREFIX/bin
444 HS_BIN_PROGS=src/htools
445
446 # Haskell programs to be installed in the MYEXECLIB dir
447 HS_MYEXECLIB_PROGS=src/mon-collector
448
449 # Haskell programs to be compiled by "make really-all"
450 HS_COMPILE_PROGS= \
451         src/ganeti-mond \
452         src/hconfd \
453         src/rpc-test
454
455 # All Haskell non-test programs to be compiled but not automatically installed
456 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
457
458 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
459 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
460
461 HS_ALL_PROGS = \
462         $(HS_PROGS) \
463         test/hs/hpc-htools \
464         test/hs/hpc-mon-collector \
465         test/hs/htest \
466         $(HS_COMPILE_PROGS)
467
468 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
469 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
470
471 HFLAGS = \
472         -O -Wall -Werror -isrc \
473         -fwarn-monomorphism-restriction \
474         -fwarn-tabs \
475         $(GHC_BYVERSION_FLAGS)
476
477 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
478 HEXTRA =
479 # internal extra flags (used for test/hs/htest mainly)
480 HEXTRA_INT =
481 # exclude options for coverage reports
482 HPCEXCL = --exclude Main \
483         --exclude Ganeti.Constants \
484         --exclude Ganeti.HTools.QC \
485         --exclude Ganeti.THH \
486         --exclude Ganeti.Version \
487         --exclude Test.Ganeti.Attoparsec \
488         --exclude Test.Ganeti.TestCommon \
489         --exclude Test.Ganeti.TestHTools \
490         --exclude Test.Ganeti.TestHelper \
491         --exclude Test.Ganeti.TestImports \
492         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
493
494 HS_LIB_SRCS = \
495         src/Ganeti/Block/Drbd/Types.hs \
496         src/Ganeti/Block/Drbd/Parser.hs \
497         src/Ganeti/BasicTypes.hs \
498         src/Ganeti/Common.hs \
499         src/Ganeti/Compat.hs \
500         src/Ganeti/Confd/Client.hs \
501         src/Ganeti/Confd/Server.hs \
502         src/Ganeti/Confd/Types.hs \
503         src/Ganeti/Confd/Utils.hs \
504         src/Ganeti/Config.hs \
505         src/Ganeti/Curl/Multi.hs \
506         src/Ganeti/Daemon.hs \
507         src/Ganeti/DataCollectors/CLI.hs \
508         src/Ganeti/DataCollectors/Drbd.hs \
509         src/Ganeti/DataCollectors/Program.hs \
510         src/Ganeti/DataCollectors/Types.hs \
511         src/Ganeti/Errors.hs \
512         src/Ganeti/HTools/Backend/IAlloc.hs \
513         src/Ganeti/HTools/Backend/Luxi.hs \
514         src/Ganeti/HTools/Backend/Rapi.hs \
515         src/Ganeti/HTools/Backend/Simu.hs \
516         src/Ganeti/HTools/Backend/Text.hs \
517         src/Ganeti/HTools/CLI.hs \
518         src/Ganeti/HTools/Cluster.hs \
519         src/Ganeti/HTools/Container.hs \
520         src/Ganeti/HTools/ExtLoader.hs \
521         src/Ganeti/HTools/Graph.hs \
522         src/Ganeti/HTools/Group.hs \
523         src/Ganeti/HTools/Instance.hs \
524         src/Ganeti/HTools/Loader.hs \
525         src/Ganeti/HTools/Node.hs \
526         src/Ganeti/HTools/PeerMap.hs \
527         src/Ganeti/HTools/Program/Hail.hs \
528         src/Ganeti/HTools/Program/Harep.hs \
529         src/Ganeti/HTools/Program/Hbal.hs \
530         src/Ganeti/HTools/Program/Hcheck.hs \
531         src/Ganeti/HTools/Program/Hinfo.hs \
532         src/Ganeti/HTools/Program/Hscan.hs \
533         src/Ganeti/HTools/Program/Hspace.hs \
534         src/Ganeti/HTools/Program/Hroller.hs \
535         src/Ganeti/HTools/Program/Main.hs \
536         src/Ganeti/HTools/Types.hs \
537         src/Ganeti/Hypervisor/Xen/XmParser.hs \
538         src/Ganeti/Hypervisor/Xen/Types.hs \
539         src/Ganeti/Hash.hs \
540         src/Ganeti/JQueue.hs \
541         src/Ganeti/JSON.hs \
542         src/Ganeti/Jobs.hs \
543         src/Ganeti/Logging.hs \
544         src/Ganeti/Luxi.hs \
545         src/Ganeti/Monitoring/Server.hs \
546         src/Ganeti/Network.hs \
547         src/Ganeti/Objects.hs \
548         src/Ganeti/OpCodes.hs \
549         src/Ganeti/OpParams.hs \
550         src/Ganeti/Path.hs \
551         src/Ganeti/Query/Common.hs \
552         src/Ganeti/Query/Export.hs \
553         src/Ganeti/Query/Filter.hs \
554         src/Ganeti/Query/Group.hs \
555         src/Ganeti/Query/Job.hs \
556         src/Ganeti/Query/Language.hs \
557         src/Ganeti/Query/Network.hs \
558         src/Ganeti/Query/Node.hs \
559         src/Ganeti/Query/Query.hs \
560         src/Ganeti/Query/Server.hs \
561         src/Ganeti/Query/Types.hs \
562         src/Ganeti/Rpc.hs \
563         src/Ganeti/Runtime.hs \
564         src/Ganeti/Ssconf.hs \
565         src/Ganeti/THH.hs \
566         src/Ganeti/Types.hs \
567         src/Ganeti/Utils.hs
568
569 HS_TEST_SRCS = \
570         test/hs/Test/Ganeti/Attoparsec.hs \
571         test/hs/Test/Ganeti/BasicTypes.hs \
572         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
573         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
574         test/hs/Test/Ganeti/Common.hs \
575         test/hs/Test/Ganeti/Confd/Types.hs \
576         test/hs/Test/Ganeti/Confd/Utils.hs \
577         test/hs/Test/Ganeti/Daemon.hs \
578         test/hs/Test/Ganeti/Errors.hs \
579         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
580         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
581         test/hs/Test/Ganeti/HTools/CLI.hs \
582         test/hs/Test/Ganeti/HTools/Cluster.hs \
583         test/hs/Test/Ganeti/HTools/Container.hs \
584         test/hs/Test/Ganeti/HTools/Graph.hs \
585         test/hs/Test/Ganeti/HTools/Instance.hs \
586         test/hs/Test/Ganeti/HTools/Loader.hs \
587         test/hs/Test/Ganeti/HTools/Node.hs \
588         test/hs/Test/Ganeti/HTools/PeerMap.hs \
589         test/hs/Test/Ganeti/HTools/Types.hs \
590         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
591         test/hs/Test/Ganeti/JSON.hs \
592         test/hs/Test/Ganeti/Jobs.hs \
593         test/hs/Test/Ganeti/JQueue.hs \
594         test/hs/Test/Ganeti/Luxi.hs \
595         test/hs/Test/Ganeti/Network.hs \
596         test/hs/Test/Ganeti/Objects.hs \
597         test/hs/Test/Ganeti/OpCodes.hs \
598         test/hs/Test/Ganeti/Query/Filter.hs \
599         test/hs/Test/Ganeti/Query/Language.hs \
600         test/hs/Test/Ganeti/Query/Network.hs \
601         test/hs/Test/Ganeti/Query/Query.hs \
602         test/hs/Test/Ganeti/Rpc.hs \
603         test/hs/Test/Ganeti/Runtime.hs \
604         test/hs/Test/Ganeti/Ssconf.hs \
605         test/hs/Test/Ganeti/THH.hs \
606         test/hs/Test/Ganeti/TestCommon.hs \
607         test/hs/Test/Ganeti/TestHTools.hs \
608         test/hs/Test/Ganeti/TestHelper.hs \
609         test/hs/Test/Ganeti/Types.hs \
610         test/hs/Test/Ganeti/Utils.hs
611
612 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
613
614 HS_BUILT_SRCS = \
615         test/hs/Test/Ganeti/TestImports.hs \
616         src/Ganeti/Constants.hs \
617         src/Ganeti/Curl/Internal.hs \
618         src/Ganeti/Version.hs
619 HS_BUILT_SRCS_IN = \
620         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
621         src/Ganeti/Curl/Internal.hsc
622
623 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
624
625 $(RUN_IN_TEMPDIR): | stamp-directories
626
627 doc/html/index.html: ENABLE_MANPAGES =
628 doc/man-html/index.html: ENABLE_MANPAGES = 1
629 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
630
631 # Note: we use here an order-only prerequisite, as the contents of
632 # _autoconf.py are not actually influencing the html build output: it
633 # has to exist in order for the sphinx module to be loaded
634 # successfully, but we certainly don't want the docs to be rebuilt if
635 # it changes
636 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
637         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
638         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
639         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
640         | $(BUILT_PYTHON_SOURCES)
641         @test -n "$(SPHINX)" || \
642             { echo 'sphinx-build' not found during configure; exit 1; }
643 if !MANPAGES_IN_DOC
644         if test -n '$(ENABLE_MANPAGES)'; then \
645           echo 'Man pages in documentation were disabled at configure time' >&2; \
646           exit 1; \
647         fi
648 endif
649 ## Sphinx provides little control over what content should be included. Some
650 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
651 ## build two different versions of the documentation--once without man pages and
652 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
653 ## us with this, but requires running in a temporary directory. It moves the
654 ## correct files into place depending on environment variables.
655         dir=$(dir $@) && \
656         @mkdir_p@ $$dir && \
657         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
658         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
659             -d . \
660             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
661             -D release="$(PACKAGE_VERSION)" \
662             -D graphviz_dot="$(DOT)" \
663             -D enable_manpages="$(ENABLE_MANPAGES)" \
664             doc $(CURDIR)/$$dir && \
665         rm -f $$dir/.buildinfo $$dir/objects.inv
666         touch $@
667
668 doc/html: doc/html/index.html
669
670 doc/man-html: doc/man-html/index.html
671
672 doc/install-quick.rst: INSTALL
673 doc/news.rst: NEWS
674 doc/upgrade.rst: UPGRADE
675
676 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
677         set -e; \
678         { echo '.. This file is automatically updated at build time from $<.'; \
679           echo '.. Do not edit.'; \
680           echo; \
681           cat $<; \
682         } > $@
683
684 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
685         { echo '.. This file is automatically generated, do not edit!'; \
686           echo ''; \
687           echo 'Man pages'; \
688           echo '========='; \
689           echo; \
690           echo '.. toctree::'; \
691           echo '   :maxdepth: 1'; \
692           echo; \
693           for i in $(notdir $(mandocrst)); do \
694             echo "   $$i"; \
695           done | LC_ALL=C sort; \
696         } > $@
697
698 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
699 if MANPAGES_IN_DOC
700         { echo '.. This file is automatically updated at build time from $<.'; \
701           echo '.. Do not edit.'; \
702           echo; \
703           echo "$*"; \
704           echo '=========================================='; \
705           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
706         } > $@
707 else
708         echo 'Man pages in documentation were disabled at configure time' >&2; \
709         exit 1;
710 endif
711
712 # Things to build but not to install (add it to EXTRA_DIST if it should be
713 # distributed)
714 noinst_DATA = \
715         doc/html \
716         $(BUILT_EXAMPLES) \
717         doc/examples/bash_completion \
718         doc/examples/bash_completion-debug \
719         $(manhtml)
720
721 if MANPAGES_IN_DOC
722 noinst_DATA += doc/man-html
723 endif
724
725 gnt_scripts = \
726         scripts/gnt-backup \
727         scripts/gnt-cluster \
728         scripts/gnt-debug \
729         scripts/gnt-group \
730         scripts/gnt-instance \
731         scripts/gnt-job \
732         scripts/gnt-network \
733         scripts/gnt-node \
734         scripts/gnt-os \
735         scripts/gnt-storage
736
737 PYTHON_BOOTSTRAP_SBIN = \
738         daemons/ganeti-masterd \
739         daemons/ganeti-noded \
740         daemons/ganeti-rapi \
741         daemons/ganeti-watcher \
742         $(gnt_scripts)
743
744 PYTHON_BOOTSTRAP = \
745         $(PYTHON_BOOTSTRAP_SBIN) \
746         tools/burnin \
747         tools/ensure-dirs \
748         tools/node-cleanup \
749         tools/node-daemon-setup \
750         tools/prepare-node-join
751
752 qa_scripts = \
753         qa/__init__.py \
754         qa/ganeti-qa.py \
755         qa/qa_cluster.py \
756         qa/qa_config.py \
757         qa/qa_daemon.py \
758         qa/qa_env.py \
759         qa/qa_error.py \
760         qa/qa_group.py \
761         qa/qa_instance.py \
762         qa/qa_job.py \
763         qa/qa_node.py \
764         qa/qa_os.py \
765         qa/qa_rapi.py \
766         qa/qa_tags.py \
767         qa/qa_utils.py
768
769 bin_SCRIPTS =
770 if WANT_HTOOLS
771 bin_SCRIPTS += $(HS_BIN_PROGS)
772 install-exec-hook:
773         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
774 # FIXME: this is a hardcoded logic, instead of auto-resolving
775         $(LN_S) -f ../../../bin/htools \
776           $(DESTDIR)$(iallocatorsdir)/hail
777         for role in $(HS_BIN_ROLES); do \
778           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
779         done
780 endif
781
782 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
783         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
784           echo "Error: cannot run unittests without the development" \
785                " libraries (see devnotes.rst)" 1>&2; \
786           exit 1; \
787         fi
788         @rm -f $(notdir $@).tix
789         $(GHC) --make \
790           $(HFLAGS) \
791           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
792           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
793           $(HEXTRA) $(HEXTRA_INT) $@
794         @touch "$@"
795
796 # for the test/hs/htest binary, we need to enable profiling/coverage
797 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
798
799 # we compile the hpc-htools binary with the program coverage
800 test/hs/hpc-htools: HEXTRA_INT=-fhpc
801
802 # we compile the hpc-mon-collector binary with the program coverage
803 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
804
805 # test dependency
806 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
807
808 # rules for building profiling-enabled versions of the haskell
809 # programs: hs-prof does the full two-step build, whereas
810 # hs-prof-quick does only the final rebuild (hs-prof must have been
811 # run before)
812 .PHONY: hs-prof hs-prof-quick
813 hs-prof:
814         @if [ -z "$(TARGET)" ]; then \
815           echo "You need to define TARGET when running this rule" 1>&2; \
816           exit 1; \
817         fi
818         $(MAKE) $(AM_MAKEFLAGS) clean
819         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
820         rm -f $(HS_ALL_PROGS)
821         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
822
823 hs-prof-quick:
824         @if [ -z "$(TARGET)" ]; then \
825           echo "You need to define TARGET when running this rule" 1>&2; \
826           exit 1; \
827         fi
828         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
829
830 dist_sbin_SCRIPTS = \
831         tools/ganeti-listrunner
832
833 nodist_sbin_SCRIPTS = \
834         $(PYTHON_BOOTSTRAP_SBIN) \
835         daemons/ganeti-cleaner
836
837 if ENABLE_CONFD
838 src/ganeti-confd: src/hconfd
839         cp -f $< $@
840
841 nodist_sbin_SCRIPTS += src/ganeti-confd
842 endif
843
844 if ENABLE_MOND
845 nodist_sbin_SCRIPTS += src/ganeti-mond
846 endif
847
848 python_scripts = \
849         tools/cfgshell \
850         tools/cfgupgrade \
851         tools/cfgupgrade12 \
852         tools/cluster-merge \
853         tools/confd-client \
854         tools/fmtjson \
855         tools/lvmstrap \
856         tools/move-instance \
857         tools/ovfconverter \
858         tools/sanitize-config
859
860 dist_tools_SCRIPTS = \
861         $(python_scripts) \
862         tools/burnin \
863         tools/kvm-console-wrapper \
864         tools/master-ip-setup \
865         tools/xen-console-wrapper
866
867 nodist_tools_python_scripts = \
868         tools/node-cleanup
869
870 nodist_tools_SCRIPTS = \
871         $(nodist_tools_python_scripts) \
872         tools/users-setup \
873         tools/vcluster-setup
874
875 pkglib_python_scripts = \
876         daemons/import-export \
877         tools/check-cert-expired
878
879 nodist_pkglib_python_scripts = \
880         tools/ensure-dirs \
881         tools/node-daemon-setup \
882         tools/prepare-node-join
883
884 myexeclib_SCRIPTS = \
885         daemons/daemon-util \
886         tools/kvm-ifup \
887         $(pkglib_python_scripts) \
888         $(HS_MYEXECLIB_PROGS)
889
890 nodist_myexeclib_SCRIPTS = \
891         $(nodist_pkglib_python_scripts)
892
893 EXTRA_DIST = \
894         NEWS \
895         UPGRADE \
896         epydoc.conf.in \
897         pylintrc \
898         autotools/build-bash-completion \
899         autotools/build-rpc \
900         autotools/check-header \
901         autotools/check-imports \
902         autotools/check-man-dashes \
903         autotools/check-man-references \
904         autotools/check-man-warnings \
905         autotools/check-news \
906         autotools/check-python-code \
907         autotools/check-tar \
908         autotools/check-version \
909         autotools/convert-constants \
910         autotools/docpp \
911         autotools/gen-py-coverage \
912         autotools/sphinx-wrapper \
913         autotools/testrunner \
914         autotools/wrong-hardcoded-paths \
915         $(RUN_IN_TEMPDIR) \
916         daemons/daemon-util.in \
917         daemons/ganeti-cleaner.in \
918         $(pkglib_python_scripts) \
919         devel/upload \
920         devel/webserver \
921         tools/kvm-ifup.in \
922         tools/users-setup.in \
923         tools/vcluster-setup.in \
924         $(docinput) \
925         doc/html \
926         $(BUILT_EXAMPLES:%=%.in) \
927         doc/examples/ganeti.default \
928         doc/examples/ganeti.default-debug \
929         doc/examples/hooks/ethers \
930         doc/examples/gnt-debug/README \
931         doc/examples/gnt-debug/delay0.json \
932         doc/examples/gnt-debug/delay50.json \
933         test/py/lockperf.py \
934         test/py/testutils.py \
935         test/py/mocks.py \
936         $(dist_TESTS) \
937         $(TEST_FILES) \
938         man/footer.rst \
939         $(manrst) \
940         $(maninput) \
941         qa/qa-sample.json \
942         $(qa_scripts) \
943         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
944         $(HS_PROG_SRCS) \
945         src/lint-hints.hs \
946         test/hs/cli-tests-defs.sh \
947         test/hs/offline-test.sh \
948         .ghci
949
950 man_MANS = \
951         man/ganeti-cleaner.8 \
952         man/ganeti-confd.8 \
953         man/ganeti-listrunner.8 \
954         man/ganeti-masterd.8 \
955         man/ganeti-mond.8 \
956         man/ganeti-noded.8 \
957         man/ganeti-os-interface.7 \
958         man/ganeti-extstorage-interface.7 \
959         man/ganeti-rapi.8 \
960         man/ganeti-watcher.8 \
961         man/ganeti.7 \
962         man/gnt-backup.8 \
963         man/gnt-cluster.8 \
964         man/gnt-debug.8 \
965         man/gnt-group.8 \
966         man/gnt-network.8 \
967         man/gnt-instance.8 \
968         man/gnt-job.8 \
969         man/gnt-node.8 \
970         man/gnt-os.8 \
971         man/gnt-storage.8 \
972         man/hail.1 \
973         man/hbal.1 \
974         man/hcheck.1 \
975         man/hinfo.1 \
976         man/hscan.1 \
977         man/hspace.1 \
978         man/hroller.1 \
979         man/htools.1 \
980         man/mon-collector.7
981
982 # Remove extensions from all filenames in man_MANS
983 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
984
985 manrst = $(patsubst %,%.rst,$(mannoext))
986 manhtml = $(patsubst %.rst,%.html,$(manrst))
987 mangen = $(patsubst %.rst,%.gen,$(manrst))
988 maninput = \
989         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
990         $(patsubst %.html,%.html.in,$(manhtml)) \
991         $(mangen)
992
993 TEST_FILES = \
994         test/data/htools/clean-nonzero-score.data \
995         test/data/htools/common-suffix.data \
996         test/data/htools/empty-cluster.data \
997         test/data/htools/hail-alloc-drbd.json \
998         test/data/htools/hail-alloc-invalid-twodisks.json \
999         test/data/htools/hail-alloc-twodisks.json \
1000         test/data/htools/hail-change-group.json \
1001         test/data/htools/hail-invalid-reloc.json \
1002         test/data/htools/hail-node-evac.json \
1003         test/data/htools/hail-reloc-drbd.json \
1004         test/data/htools/hbal-excl-tags.data \
1005         test/data/htools/hbal-split-insts.data \
1006         test/data/htools/hspace-tiered-dualspec.data \
1007         test/data/htools/hspace-tiered.data \
1008         test/data/htools/invalid-node.data \
1009         test/data/htools/missing-resources.data \
1010         test/data/htools/multiple-master.data \
1011         test/data/htools/n1-failure.data \
1012         test/data/htools/rapi/groups.json \
1013         test/data/htools/rapi/info.json \
1014         test/data/htools/rapi/instances.json \
1015         test/data/htools/rapi/nodes.json \
1016         test/data/htools/unique-reboot-order.data \
1017         test/hs/shelltests/htools-balancing.test \
1018         test/hs/shelltests/htools-basic.test \
1019         test/hs/shelltests/htools-dynutil.test \
1020         test/hs/shelltests/htools-excl.test \
1021         test/hs/shelltests/htools-hail.test \
1022         test/hs/shelltests/htools-hroller.test \
1023         test/hs/shelltests/htools-hspace.test \
1024         test/hs/shelltests/htools-invalid.test \
1025         test/hs/shelltests/htools-multi-group.test \
1026         test/hs/shelltests/htools-no-backend.test \
1027         test/hs/shelltests/htools-rapi.test \
1028         test/hs/shelltests/htools-single-group.test \
1029         test/hs/shelltests/htools-text-backend.test \
1030         test/hs/shelltests/htools-mon-collector.test \
1031         test/data/bdev-drbd-8.0.txt \
1032         test/data/bdev-drbd-8.3.txt \
1033         test/data/bdev-drbd-disk.txt \
1034         test/data/bdev-drbd-net-ip4.txt \
1035         test/data/bdev-drbd-net-ip6.txt \
1036         test/data/bdev-rbd/json_output_empty.txt \
1037         test/data/bdev-rbd/json_output_extra_matches.txt \
1038         test/data/bdev-rbd/json_output_no_matches.txt \
1039         test/data/bdev-rbd/json_output_ok.txt \
1040         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1041         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1042         test/data/bdev-rbd/plain_output_new_ok.txt \
1043         test/data/bdev-rbd/plain_output_old_empty.txt \
1044         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1045         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1046         test/data/bdev-rbd/plain_output_old_ok.txt \
1047         test/data/bdev-rbd/output_invalid.txt \
1048         test/data/cert1.pem \
1049         test/data/cert2.pem \
1050         test/data/cluster_config_2.7.json \
1051         test/data/cluster_config_downgraded_2.7.json \
1052         test/data/instance-minor-pairing.txt \
1053         test/data/ip-addr-show-dummy0.txt \
1054         test/data/ip-addr-show-lo-ipv4.txt \
1055         test/data/ip-addr-show-lo-ipv6.txt \
1056         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1057         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1058         test/data/ip-addr-show-lo-oneline.txt \
1059         test/data/ip-addr-show-lo.txt \
1060         test/data/kvm_0.12.5_help.txt \
1061         test/data/kvm_0.15.90_help.txt \
1062         test/data/kvm_0.9.1_help.txt \
1063         test/data/kvm_0.9.1_help_boot_test.txt \
1064         test/data/kvm_1.0_help.txt \
1065         test/data/kvm_1.1.2_help.txt \
1066         test/data/ovfdata/compr_disk.vmdk.gz \
1067         test/data/ovfdata/config.ini \
1068         test/data/ovfdata/corrupted_resources.ovf \
1069         test/data/ovfdata/empty.ini \
1070         test/data/ovfdata/empty.ovf \
1071         test/data/ovfdata/ganeti.mf \
1072         test/data/ovfdata/ganeti.ovf \
1073         test/data/ovfdata/gzip_disk.ovf \
1074         test/data/ovfdata/new_disk.vmdk \
1075         test/data/ovfdata/no_disk.ini \
1076         test/data/ovfdata/no_disk_in_ref.ovf \
1077         test/data/ovfdata/no_os.ini \
1078         test/data/ovfdata/no_ovf.ova \
1079         test/data/ovfdata/other/rawdisk.raw \
1080         test/data/ovfdata/ova.ova \
1081         test/data/ovfdata/rawdisk.raw \
1082         test/data/ovfdata/second_disk.vmdk \
1083         test/data/ovfdata/unsafe_path.ini \
1084         test/data/ovfdata/virtualbox.ovf \
1085         test/data/ovfdata/wrong_config.ini \
1086         test/data/ovfdata/wrong_extension.ovd \
1087         test/data/ovfdata/wrong_manifest.mf \
1088         test/data/ovfdata/wrong_manifest.ovf \
1089         test/data/ovfdata/wrong_ova.ova \
1090         test/data/ovfdata/wrong_xml.ovf \
1091         test/data/proc_drbd8.txt \
1092         test/data/proc_drbd80-emptyline.txt \
1093         test/data/proc_drbd83.txt \
1094         test/data/proc_drbd83_sync.txt \
1095         test/data/proc_drbd83_sync_want.txt \
1096         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1097         test/data/qa-minimal-nodes-instances-only.json \
1098         test/data/sys_drbd_usermode_helper.txt \
1099         test/data/vgreduce-removemissing-2.02.02.txt \
1100         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1101         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1102         test/data/vgs-missing-pvs-2.02.02.txt \
1103         test/data/vgs-missing-pvs-2.02.66.txt \
1104         test/data/xen-xm-info-4.0.1.txt \
1105         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1106         test/data/xen-xm-list-4.0.1-four-instances.txt \
1107         test/data/xen-xm-list-long-4.0.1.txt \
1108         test/data/xen-xm-uptime-4.0.1.txt \
1109         test/py/ganeti-cli.test \
1110         test/py/gnt-cli.test \
1111         test/py/import-export_unittest-helper
1112
1113 python_tests = \
1114         doc/examples/rapi_testutils.py \
1115         test/py/cfgupgrade_unittest.py \
1116         test/py/docs_unittest.py \
1117         test/py/ganeti.asyncnotifier_unittest.py \
1118         test/py/ganeti.backend_unittest-runasroot.py \
1119         test/py/ganeti.backend_unittest.py \
1120         test/py/ganeti.bdev_unittest.py \
1121         test/py/ganeti.cli_unittest.py \
1122         test/py/ganeti.client.gnt_cluster_unittest.py \
1123         test/py/ganeti.client.gnt_instance_unittest.py \
1124         test/py/ganeti.client.gnt_job_unittest.py \
1125         test/py/ganeti.cmdlib_unittest.py \
1126         test/py/ganeti.compat_unittest.py \
1127         test/py/ganeti.confd.client_unittest.py \
1128         test/py/ganeti.config_unittest.py \
1129         test/py/ganeti.constants_unittest.py \
1130         test/py/ganeti.daemon_unittest.py \
1131         test/py/ganeti.errors_unittest.py \
1132         test/py/ganeti.hooks_unittest.py \
1133         test/py/ganeti.ht_unittest.py \
1134         test/py/ganeti.http_unittest.py \
1135         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1136         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1137         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1138         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1139         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1140         test/py/ganeti.hypervisor_unittest.py \
1141         test/py/ganeti.impexpd_unittest.py \
1142         test/py/ganeti.jqueue_unittest.py \
1143         test/py/ganeti.jstore_unittest.py \
1144         test/py/ganeti.locking_unittest.py \
1145         test/py/ganeti.luxi_unittest.py \
1146         test/py/ganeti.masterd.iallocator_unittest.py \
1147         test/py/ganeti.masterd.instance_unittest.py \
1148         test/py/ganeti.mcpu_unittest.py \
1149         test/py/ganeti.netutils_unittest.py \
1150         test/py/ganeti.objects_unittest.py \
1151         test/py/ganeti.opcodes_unittest.py \
1152         test/py/ganeti.outils_unittest.py \
1153         test/py/ganeti.ovf_unittest.py \
1154         test/py/ganeti.qlang_unittest.py \
1155         test/py/ganeti.query_unittest.py \
1156         test/py/ganeti.rapi.baserlib_unittest.py \
1157         test/py/ganeti.rapi.client_unittest.py \
1158         test/py/ganeti.rapi.resources_unittest.py \
1159         test/py/ganeti.rapi.rlib2_unittest.py \
1160         test/py/ganeti.rapi.testutils_unittest.py \
1161         test/py/ganeti.rpc_unittest.py \
1162         test/py/ganeti.runtime_unittest.py \
1163         test/py/ganeti.serializer_unittest.py \
1164         test/py/ganeti.server.rapi_unittest.py \
1165         test/py/ganeti.ssconf_unittest.py \
1166         test/py/ganeti.ssh_unittest.py \
1167         test/py/ganeti.storage_unittest.py \
1168         test/py/ganeti.tools.burnin_unittest.py \
1169         test/py/ganeti.tools.ensure_dirs_unittest.py \
1170         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1171         test/py/ganeti.tools.prepare_node_join_unittest.py \
1172         test/py/ganeti.uidpool_unittest.py \
1173         test/py/ganeti.utils.algo_unittest.py \
1174         test/py/ganeti.utils.filelock_unittest.py \
1175         test/py/ganeti.utils.hash_unittest.py \
1176         test/py/ganeti.utils.io_unittest-runasroot.py \
1177         test/py/ganeti.utils.io_unittest.py \
1178         test/py/ganeti.utils.log_unittest.py \
1179         test/py/ganeti.utils.lvm_unittest.py \
1180         test/py/ganeti.utils.mlock_unittest.py \
1181         test/py/ganeti.utils.nodesetup_unittest.py \
1182         test/py/ganeti.utils.process_unittest.py \
1183         test/py/ganeti.utils.retry_unittest.py \
1184         test/py/ganeti.utils.text_unittest.py \
1185         test/py/ganeti.utils.wrapper_unittest.py \
1186         test/py/ganeti.utils.x509_unittest.py \
1187         test/py/ganeti.utils_unittest.py \
1188         test/py/ganeti.vcluster_unittest.py \
1189         test/py/ganeti.workerpool_unittest.py \
1190         test/py/pycurl_reset_unittest.py \
1191         test/py/qa.qa_config_unittest.py \
1192         test/py/tempfile_fork_unittest.py
1193
1194 haskell_tests = test/hs/htest
1195
1196 dist_TESTS = \
1197         test/py/check-cert-expired_unittest.bash \
1198         test/py/daemon-util_unittest.bash \
1199         test/py/ganeti-cleaner_unittest.bash \
1200         test/py/import-export_unittest.bash \
1201         test/py/cli-test.bash \
1202         test/py/bash_completion.bash \
1203         $(python_tests)
1204
1205 nodist_TESTS =
1206 check_SCRIPTS =
1207
1208 if WANT_HSTESTS
1209 nodist_TESTS += $(haskell_tests)
1210 dist_TESTS += test/hs/offline-test.sh
1211 check_SCRIPTS += \
1212         test/hs/hpc-htools \
1213         test/hs/hpc-mon-collector \
1214         $(HS_BUILT_TEST_HELPERS)
1215 endif
1216
1217 TESTS = $(dist_TESTS) $(nodist_TESTS)
1218
1219 # Environment for all tests
1220 PLAIN_TESTS_ENVIRONMENT = \
1221         PYTHONPATH=. \
1222         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1223         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1224         $(RUN_IN_TEMPDIR)
1225
1226 # Environment for tests run by automake
1227 TESTS_ENVIRONMENT = \
1228         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1229
1230 all_python_code = \
1231         $(dist_sbin_SCRIPTS) \
1232         $(python_scripts) \
1233         $(pkglib_python_scripts) \
1234         $(nodist_pkglib_python_scripts) \
1235         $(nodist_tools_python_scripts) \
1236         $(python_tests) \
1237         $(pkgpython_PYTHON) \
1238         $(client_PYTHON) \
1239         $(hypervisor_PYTHON) \
1240         $(rapi_PYTHON) \
1241         $(server_PYTHON) \
1242         $(pytools_PYTHON) \
1243         $(http_PYTHON) \
1244         $(confd_PYTHON) \
1245         $(masterd_PYTHON) \
1246         $(impexpd_PYTHON) \
1247         $(utils_PYTHON) \
1248         $(watcher_PYTHON) \
1249         $(noinst_PYTHON) \
1250         $(qa_scripts)
1251
1252 srclink_files = \
1253         man/footer.rst \
1254         test/py/check-cert-expired_unittest.bash \
1255         test/py/daemon-util_unittest.bash \
1256         test/py/ganeti-cleaner_unittest.bash \
1257         test/py/import-export_unittest.bash \
1258         test/py/cli-test.bash \
1259         test/py/bash_completion.bash \
1260         test/hs/offline-test.sh \
1261         test/hs/cli-tests-defs.sh \
1262         $(all_python_code) \
1263         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1264         $(docinput)
1265
1266 check_python_code = \
1267         $(BUILD_BASH_COMPLETION) \
1268         $(CHECK_IMPORTS) \
1269         $(CHECK_HEADER) \
1270         $(DOCPP) \
1271         $(all_python_code)
1272
1273 lint_python_code = \
1274         ganeti \
1275         ganeti/http/server.py \
1276         $(dist_sbin_SCRIPTS) \
1277         $(python_scripts) \
1278         $(pkglib_python_scripts) \
1279         $(BUILD_BASH_COMPLETION) \
1280         $(CHECK_IMPORTS) \
1281         $(CHECK_HEADER) \
1282         $(DOCPP) \
1283         $(PYTHON_BOOTSTRAP)
1284
1285 standalone_python_modules = \
1286         lib/rapi/client.py \
1287         tools/ganeti-listrunner
1288
1289 pep8_python_code = \
1290         ganeti \
1291         ganeti/http/server.py \
1292         $(dist_sbin_SCRIPTS) \
1293         $(python_scripts) \
1294         $(pkglib_python_scripts) \
1295         $(BUILD_BASH_COMPLETION) \
1296         $(CHECK_HEADER) \
1297         $(DOCPP) \
1298         $(PYTHON_BOOTSTRAP) \
1299         qa
1300
1301 test/py/daemon-util_unittest.bash: daemons/daemon-util
1302
1303 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1304
1305 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1306
1307 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1308         sed -f $(REPLACE_VARS_SED) < $< > $@
1309         chmod +x $@
1310
1311 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1312         sed -f $(REPLACE_VARS_SED) < $< > $@
1313         chmod +x $@
1314
1315 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1316         sed -f $(REPLACE_VARS_SED) < $< > $@
1317         chmod +x $@
1318
1319 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1320         sed -f $(REPLACE_VARS_SED) < $< > $@
1321         chmod +x $@
1322
1323 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1324         sed -f $(REPLACE_VARS_SED) < $< > $@
1325
1326 doc/examples/bash_completion: BC_ARGS = --compact
1327 doc/examples/bash_completion-debug: BC_ARGS =
1328
1329 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1330         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1331         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1332         daemons/ganeti-cleaner \
1333         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1334         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1335           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1336
1337 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1338         lib/build/shell_example_lexer.py \
1339         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1340         @echo "Checking $< for hardcoded paths..."
1341         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1342           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1343           exit 1; \
1344         fi
1345         set -e ; \
1346         trap 'echo auto-removing $@; rm $@' EXIT; \
1347         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1348         $(CHECK_MAN_REFERENCES) $@; \
1349         trap - EXIT
1350
1351 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1352         @test -n "$(PANDOC)" || \
1353           { echo 'pandoc' not found during configure; exit 1; }
1354         set -o pipefail -e; \
1355         trap 'echo auto-removing $@; rm $@' EXIT; \
1356         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1357           sed -e 's/\\@/@/g' > $@; \
1358         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1359         $(CHECK_MAN_DASHES) $@; \
1360         trap - EXIT
1361
1362 man/%.html.in: man/%.gen man/footer.rst
1363         @test -n "$(PANDOC)" || \
1364           { echo 'pandoc' not found during configure; exit 1; }
1365         set -o pipefail ; \
1366         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1367           sed -e 's/\\@/@/g' > $@
1368
1369 man/%: man/%.in  $(REPLACE_VARS_SED)
1370         sed -f $(REPLACE_VARS_SED) < $< > $@
1371
1372 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1373         sed -f $(REPLACE_VARS_SED) < $< > $@
1374
1375 vcs-version:
1376         if test -d .git; then \
1377           git describe > $@; \
1378         elif test ! -f $@ ; then \
1379           echo "Cannot auto-generate $@ file"; exit 1; \
1380         fi
1381
1382 .PHONY: clean-vcs-version
1383 clean-vcs-version:
1384         rm -f vcs-version
1385
1386 .PHONY: regen-vcs-version
1387 regen-vcs-version:
1388         @set -e; \
1389         cd $(srcdir); \
1390         if test -d .git; then \
1391           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1392           git describe > $$T; \
1393           if ! cmp --quiet $$T vcs-version; then \
1394             mv $$T vcs-version; \
1395           fi; \
1396         fi
1397
1398 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1399         vcs-version $(built_base_sources)
1400         set -e; \
1401         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1402         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1403
1404 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1405         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1406         lib/jstore.py $(RUN_IN_TEMPDIR) \
1407         $(CONVERT_CONSTANTS) $(built_base_sources) \
1408         | lib/_vcsversion.py
1409         set -e; \
1410         { cat $< ; \
1411           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1412         } > $@
1413
1414 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1415         hsc2hs -o $@ $<
1416
1417 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1418         $(built_base_sources)
1419         set -e; \
1420         { cat $< ; \
1421           echo ; \
1422           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1423             echo "import $$name ()" ; \
1424           done ; \
1425         } > $@
1426
1427 lib/_autoconf.py: Makefile | stamp-directories
1428         set -e; \
1429         { echo '# This file is automatically generated, do not edit!'; \
1430           echo '#'; \
1431           echo ''; \
1432           echo '"""Build-time configuration for Ganeti.'; \
1433           echo '';\
1434           echo 'This file is autogenerated by the build process.'; \
1435           echo 'For any changes you need to re-run ./configure (and'; \
1436           echo 'not edit by hand).'; \
1437           echo ''; \
1438           echo '"""'; \
1439           echo ''; \
1440           echo '# pylint: disable=C0301,C0324'; \
1441           echo '# because this is autogenerated, we do not want'; \
1442           echo '# style warnings' ; \
1443           echo ''; \
1444           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1445           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1446           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1447           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1448           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1449           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1450           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1451           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1452           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1453           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1454           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1455           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1456           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1457           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1458           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1459           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1460           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1461           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1462           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1463           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1464           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1465           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1466           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1467           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1468           echo "KVM_PATH = '$(KVM_PATH)'"; \
1469           echo "IP_PATH = '$(IP_PATH)'"; \
1470           echo "SOCAT_PATH = '$(SOCAT)'"; \
1471           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1472           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1473           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1474           echo "TOOLSDIR = '$(toolsdir)'"; \
1475           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1476           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1477           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1478           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1479           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1480           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1481           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1482           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1483           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1484           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1485           echo "RAPI_USER = '$(RAPI_USER)'"; \
1486           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1487           echo "CONFD_USER = '$(CONFD_USER)'"; \
1488           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1489           echo "NODED_USER = '$(NODED_USER)'"; \
1490           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1491           echo "MOND_USER = '$(MOND_USER)'"; \
1492           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1493           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1494           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1495           echo "HTOOLS = True"; \
1496           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1497           echo "XEN_CMD = '$(XEN_CMD)'"; \
1498           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1499           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1500           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1501 ## Write dictionary with man page name as the key and the section number as the
1502 ## value
1503           echo "MAN_PAGES = {"; \
1504           for i in $(notdir $(man_MANS)); do \
1505             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1506           done; \
1507           echo "}"; \
1508         } > $@
1509
1510 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1511         set -e; \
1512         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1513         { echo '# This file is automatically generated, do not edit!'; \
1514           echo '#'; \
1515           echo ''; \
1516           echo '"""Build-time VCS version number for Ganeti.'; \
1517           echo '';\
1518           echo 'This file is autogenerated by the build process.'; \
1519           echo 'For any changes you need to re-run ./configure (and'; \
1520           echo 'not edit by hand).'; \
1521           echo ''; \
1522           echo '"""'; \
1523           echo ''; \
1524           echo '# pylint: disable=C0301,C0324'; \
1525           echo '# because this is autogenerated, we do not want'; \
1526           echo '# style warnings' ; \
1527           echo ''; \
1528           echo "VCS_VERSION = '$$VCSVER'"; \
1529         } > $@
1530
1531 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1532         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1533
1534 $(SHELL_ENV_INIT): Makefile stamp-directories
1535         set -e; \
1536         { echo '# Allow overriding for tests'; \
1537           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1538           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1539           echo; \
1540           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1541           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1542           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1543           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1544           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1545         } > $@
1546
1547 ## Writes sed script to replace placeholders with build-time values. The
1548 ## additional quotes after the first @ sign are necessary to stop configure
1549 ## from replacing those values as well.
1550 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1551         set -e; \
1552         { echo 's#@''PREFIX@#$(prefix)#g'; \
1553           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1554           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1555           echo 's#@''BINDIR@#$(bindir)#g'; \
1556           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1557           echo 's#@''LIBDIR@#$(libdir)#g'; \
1558           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1559           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1560           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1561           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1562           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1563           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1564           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1565           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1566           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1567           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1568           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1569           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1570           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1571           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1572           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1573           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1574           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1575           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1576           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1577           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1578           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1579           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1580           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1581           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1582           echo; \
1583           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1584           echo '  r $(SHELL_ENV_INIT)'; \
1585           echo '  d'; \
1586           echo '}'; \
1587         } > $@
1588
1589 # Using deferred evaluation
1590 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1591 daemons/ganeti-watcher: MODULE = ganeti.watcher
1592 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1593 tools/burnin: MODULE = ganeti.tools.burnin
1594 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1595 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1596 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1597 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1598 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1599
1600 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1601         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1602         set -e; \
1603         { echo '#!/usr/bin/python'; \
1604           echo '# This file is automatically generated, do not edit!'; \
1605           echo "# Edit $(MODULE) instead."; \
1606           echo; \
1607           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1608           echo; \
1609           echo '# pylint: disable=C0103'; \
1610           echo '# C0103: Invalid name'; \
1611           echo; \
1612           echo 'import sys'; \
1613           echo 'import $(MODULE) as main'; \
1614           echo; \
1615           echo '# Temporarily alias commands until bash completion'; \
1616           echo '# generator is changed'; \
1617           echo 'if hasattr(main, "commands"):'; \
1618           echo '  commands = main.commands # pylint: disable=E1101'; \
1619           echo 'if hasattr(main, "aliases"):'; \
1620           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1621           echo; \
1622           echo 'if __name__ == "__main__":'; \
1623           echo '  sys.exit(main.Main())'; \
1624         } > $@
1625         chmod u+x $@
1626
1627 $(HS_BUILT_TEST_HELPERS): Makefile
1628         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1629         set -e; \
1630         { echo '#!/bin/sh'; \
1631           echo '# This file is automatically generated, do not edit!'; \
1632           echo "# Edit Makefile.am instead."; \
1633           echo; \
1634           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1635         } > $@
1636         chmod u+x $@
1637
1638 stamp-directories: Makefile
1639         $(MAKE) $(AM_MAKEFLAGS) ganeti
1640         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1641         touch $@
1642
1643 # We need to create symlinks because "make distcheck" will not install Python
1644 # files when building.
1645 stamp-srclinks: Makefile | stamp-directories
1646         set -e; \
1647         for i in $(srclink_files); do \
1648           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1649             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1650           fi; \
1651         done
1652         touch $@
1653
1654 .PHONY: ganeti
1655 ganeti:
1656         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1657
1658 .PHONY: check-dirs
1659 check-dirs: $(GENERATED_FILES)
1660         @set -e; \
1661         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1662           error=; \
1663           while read dir; do \
1664             case "$$dir" in \
1665               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1666               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1667             esac; \
1668           done; \
1669           for dir in $(DIRS); do \
1670             if ! test -d "$$dir"; then \
1671               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1672               error=1; \
1673             fi \
1674           done; \
1675           test -z "$$error"; \
1676         }
1677
1678 .PHONY: check-local
1679 check-local: check-dirs $(GENERATED_FILES)
1680         $(CHECK_PYTHON_CODE) $(check_python_code)
1681         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1682         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1683         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1684         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1685         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1686         error= ; \
1687         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1688           echo "Incorrect version in README, expected $$expver" >&2; \
1689           error=1; \
1690         fi; \
1691         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1692             doc/security.rst; do \
1693           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1694             "Documents Ganeti version $$expver"; then \
1695             echo "Incorrect version in $$file, expected $$expver" >&2; \
1696             error=1; \
1697           fi; \
1698         done; \
1699         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1700           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1701           error=1; \
1702         fi; \
1703         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1704           ".. Last updated for Ganeti $$expver"; then \
1705           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1706           error=1; \
1707         fi; \
1708         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1709           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1710             echo "Longest line in $$file is longer than 80 characters" >&2; \
1711             error=1; \
1712           fi; \
1713         done; \
1714         test -z "$$error"
1715
1716 .PHONY: hs-tests
1717 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1718         @rm -f htest.tix
1719         ./test/hs/htest
1720
1721 .PHONY: hs-shell
1722 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1723         @rm -f hpc-htools.tix hpc-mon-collector.tix
1724         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1725
1726 .PHONY: hs-check
1727 hs-check: hs-tests hs-shell
1728
1729 # E111: indentation is not a multiple of four
1730 # E121: continuation line indentation is not a multiple of four
1731 #       (since our indent level is not 4)
1732 # E125: continuation line does not distinguish itself from next logical line
1733 #       (since our indent level is not 4)
1734 # E127: continuation line over-indented for visual indent
1735 #       (since our indent level is not 4)
1736 # note: do NOT add E128 here; it's a valid style error in most cases!
1737 # I've seen real errors, but also some cases were we indent wrongly
1738 # due to line length; try to rework the cases where it is triggered,
1739 # instead of silencing it
1740 # E261: at least two spaces before inline comment
1741 # E501: line too long (80 characters)
1742 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1743
1744 # For excluding pep8 expects filenames only, not whole paths
1745 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1746
1747 LINT_TARGETS = pylint pylint-qa
1748 if HAS_PEP8
1749 LINT_TARGETS += pep8
1750 endif
1751 if HAS_HLINT
1752 LINT_TARGETS += hlint
1753 endif
1754
1755 .PHONY: lint
1756 lint: $(LINT_TARGETS)
1757
1758 .PHONY: pylint
1759 pylint: $(GENERATED_FILES)
1760         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1761         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1762
1763 .PHONY: pylint-qa
1764 pylint-qa: $(GENERATED_FILES)
1765         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1766         cd $(top_srcdir)/qa && \
1767           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1768           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1769
1770 .PHONY: pep8
1771 pep8: $(GENERATED_FILES)
1772         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1773         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1774           --repeat $(pep8_python_code)
1775
1776 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1777 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1778 .PHONY: hlint
1779 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1780         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1781         @rm -f doc/hs-lint.html
1782         if tty -s; then C="-c"; else C=""; fi; \
1783         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1784           --ignore "Use first" \
1785           --ignore "Use &&&" \
1786           --ignore "Use void" \
1787           --ignore "Reduce duplication" \
1788           --hint src/lint-hints \
1789           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1790         @if [ ! -f doc/hs-lint.html ]; then \
1791           echo "All good" > doc/hs-lint.html; \
1792         fi
1793
1794 # a dist hook rule for updating the vcs-version file; this is
1795 # hardcoded due to where it needs to build the file...
1796 dist-hook:
1797         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1798         rm -f $(top_distdir)/vcs-version
1799         cp -p $(srcdir)/vcs-version $(top_distdir)
1800
1801 # a distcheck hook rule for catching revision control directories
1802 distcheck-hook:
1803         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1804           echo "Found revision control files in final archive." 1>&2; \
1805           exit 1; \
1806         fi
1807         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1808           echo "Found Python byte code in final archive." 1>&2; \
1809           exit 1; \
1810         fi
1811         if find $(top_distdir) -name '*~' | grep .; then \
1812           echo "Found backup files in final archive." 1>&2; \
1813           exit 1; \
1814         fi
1815 # Empty files or directories should not be distributed. They can cause
1816 # unnecessary warnings for packagers. Directories used by automake during
1817 # distcheck must be excluded.
1818         if find $(top_distdir) -empty -and -not \( \
1819             -path $(top_distdir)/_build -or \
1820             -path $(top_distdir)/_inst \) | grep .; then \
1821           echo "Found empty files or directories in final archive." 1>&2; \
1822           exit 1; \
1823         fi
1824         if test -e $(top_distdir)/doc/man-html; then \
1825           echo "Found documentation including man pages in final archive" >&2; \
1826           exit 1; \
1827         fi
1828
1829 # Backwards compatible distcheck-release target
1830 distcheck-release: distcheck
1831
1832 distrebuildcheck: dist
1833         set -e; \
1834         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1835         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1836         cd $$builddir; \
1837         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1838         cd $(distdir); \
1839         ./configure; \
1840         $(MAKE) maintainer-clean; \
1841         cp $(abs_srcdir)/vcs-version .; \
1842         ./configure; \
1843         $(MAKE) $(AM_MAKEFLAGS)
1844
1845 dist-release: dist
1846         set -e; \
1847         for i in $(DIST_ARCHIVES); do \
1848           echo -n "Checking $$i ... "; \
1849           autotools/check-tar < $$i; \
1850           echo OK; \
1851         done
1852
1853 install-exec-local:
1854         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1855           "$(DESTDIR)${localstatedir}/log/ganeti" \
1856           "$(DESTDIR)${localstatedir}/run/ganeti"
1857
1858 .PHONY: apidoc
1859 if WANT_HSAPIDOC
1860 apidoc: py-apidoc hs-apidoc
1861 else
1862 apidoc: py-apidoc
1863 endif
1864
1865 .PHONY: py-apidoc
1866 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1867         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1868         $(RUN_IN_TEMPDIR) epydoc -v \
1869           --conf $(CURDIR)/epydoc.conf \
1870           --output $(CURDIR)/$(APIDOC_PY_DIR)
1871
1872 .PHONY: hs-apidoc
1873 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1874
1875 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1876         @test -n "$(HSCOLOUR)" || \
1877             { echo 'HsColour' not found during configure; exit 1; }
1878         @test -n "$(HADDOCK)" || \
1879             { echo 'haddock' not found during configure; exit 1; }
1880         rm -rf $(APIDOC_HS_DIR)/*
1881         for i in $(ALL_APIDOC_HS_DIRS); do \
1882           @mkdir_p@ $$i; \
1883           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1884         done
1885         set -e ; \
1886         export LC_ALL=en_US.UTF-8; \
1887         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1888         if [ "$(HS_PARALLEL3)" ]; \
1889         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1890         fi; \
1891         if [ "$(HS_REGEX_PCRE)" ]; \
1892         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1893         fi; \
1894         for file in $(HS_LIBTESTBUILT_SRCS); do \
1895           f_nosrc=$${file##src/}; \
1896           f_notst=$${f_nosrc##test/hs/}; \
1897           f_html=$${f_notst%%.hs}.html; \
1898           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1899         done ; \
1900         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1901           -t ganeti -p src/haddock-prologue \
1902           --source-module="%{MODULE/.//}.html" \
1903           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1904           $$OPTGHC \
1905           $(HS_LIBTESTBUILT_SRCS)
1906
1907 .PHONY: TAGS
1908 TAGS: $(GENERATED_FILES)
1909         rm -f TAGS
1910         $(GHC) -e ":etags" -v0 \
1911           $(filter-out -O -Werror,$(HFLAGS)) \
1912           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1913           $(HS_LIBTEST_SRCS)
1914         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1915           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1916           -path './qa/*.py' | \
1917           etags -l python -a -
1918
1919 .PHONY: coverage
1920 if WANT_HTOOLS
1921 coverage: py-coverage hs-coverage
1922 else
1923 coverage: py-coverage
1924 endif
1925
1926 .PHONY: py-coverage
1927 py-coverage: $(GENERATED_FILES) $(python_tests)
1928         @test -n "$(PYCOVERAGE)" || \
1929             { echo 'python-coverage' not found during configure; exit 1; }
1930         set -e; \
1931         COVERAGE=$(PYCOVERAGE) \
1932         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1933         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1934         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1935         $(PLAIN_TESTS_ENVIRONMENT) \
1936         $(abs_top_srcdir)/autotools/gen-py-coverage \
1937         $(python_tests)
1938
1939 .PHONY: hs-coverage
1940 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1941         rm -f *.tix
1942         $(MAKE) $(AM_MAKEFLAGS) hs-check
1943         @mkdir_p@ $(COVERAGE_HS_DIR)
1944         hpc sum --union $(HPCEXCL) \
1945           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1946         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1947         hpc report coverage-hs.tix
1948         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1949
1950 # Special "kind-of-QA" target for htools, needs special setup (all
1951 # tools compiled with -fhpc)
1952 .PHONY: live-test
1953 live-test: all
1954         set -e ; \
1955         cd src; \
1956         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1957         rm -f *.tix *.mix; \
1958         ./live-test.sh; \
1959         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1960           --output=live-test.tix ; \
1961         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1962         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1963           --srcdir=.. $(HPCEXCL) ; \
1964         hpc report --srcdir=.. live-test $(HPCEXCL)
1965
1966 commit-check: distcheck lint apidoc
1967
1968 .PHONY: gitignore-check
1969 gitignore-check:
1970         @if [ -n "`git status --short`" ]; then \
1971           echo "Git status is not clean!" 1>&2 ; \
1972           git status --short; \
1973           exit 1; \
1974         fi
1975
1976 # target to rebuild all man pages (both groff and html output)
1977 .PHONY: man
1978 man: $(man_MANS) $(manhtml)
1979
1980 # Target that builds all binaries (including those that are not
1981 # rebuilt except when running the tests)
1982 .PHONY: really-all
1983 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1984
1985 # we don't need the ancient implicit rules:
1986 %: %,v
1987 %: RCS/%,v
1988 %: RCS/%
1989 %: s.%
1990 %: SCCS/s.%
1991
1992 -include ./Makefile.local
1993
1994 # vim: set noet :